/* -------------------------------- pwd ------------------------------------ *\
\* ========================================================================= */
// gives a TI-89, TI-92 or a V200 a login procedure
// written by fasmat in 2004/05
// read NFO!
#define COMMENT_STRING "PWD 1.3 by fasmat in 2004/05"
#define COMMENT_PROGRAM_NAME "pwd"


#include <system.h>
#include <graph.h>
#include <string.h>
#include <kbd.h>
#include <stdio.h>
#include <stdlib.h>
#include <compat.h>
#include <intr.h>
#include <statline.h>


       char pwd[16];
static int  savedPwd0 = 0,
            savedPwd1 = 0,
            savedPwd2 = 0,
            savedPwd3 = 0,
            savedPwd4 = 0,
            savedPwd5 = 0,
            savedPwd6 = 0,
            savedPwd7 = 0,
            savedPwd8 = 0,
            savedPwd9 = 0,
            savedPwd10 = 0,
            savedPwd11 = 0,
            savedPwd12 = 0,
            savedPwd13 = 0,
            savedPwd14 = 0,
            savedPwd15 = 0;

INT_HANDLER oldint5 = NULL;  // adress of original interrupt 5
                             // necessary to restory it after the programm exits

volatile int counter = 0;    // the counter for my own interrupt
volatile int seconds = 0;    // it counts the secounds
volatile int startint = 0;   // is used to start my interrupt
volatile int resetint = 1;   // is used to reset my interrupt


/* --------------------------- HomeScreenRestore --------------------------- *\
\* ========================================================================= */
// original by Greg Dietsche (HSR 3.0 - 06/19/2002)
// restores HomeScreen
void HomeScreenRestore(void);
asm("HomeScreenRestore:\n"\
"     movem.l  %d0-%d7/%a0-%a6,-(%a7)\n"\
"     movea.l  0xC8,%a4\n"\
"     movea.l  (0x124,%a4),%a0\n"\
"     jsr      (%a0)               | call MenuUpdate\n"\
"     move.w   #0xA,-(%a7)\n"\
"     movea.l  (0x3AC,%a4),%a0\n"\
"     jsr      (%a0)               | call ST_refDsp with empty message\n"\
"     movea.l  (0x38C,%a4),%a0\n"\
"     jsr      (%a0)               | call ST_eraseHelp\n"\
"     move.l   #0x1E,-(%a7)\n"\
"     move.w   #0xFF,-(%a7)\n"\
"     move.l   %a4,%d0\n"\
"     andi.l   #0xE00000,%d0\n"\
"     cmpi.l   #0x800000,%d0\n"\
"     beq.s    ____ti89            | TI-89T\n"\
"     cmpi.l   #0x400000,%d0\n"\
"     beq.s    ____ti92PV200       | TI-92P\n"\
"     cmpi.l   #0x200000,%d0\n"
"     bne.s    ____other_model     | unknown model, skip.\n"
"     movea.l  (0xBC,%a4),%a0\n"\
"     cmpi.b   #0xEF,(0x2,%a0)\n"\
"     beq.s    ____ti92PV200       | V200\n"\
"____ti89:\n"\
"| TI-89/TI-89T\n"\
"     pea      0x56E6.w\n"\
"     bra.s    ____drawline\n"\
"____ti92PV200:\n"\
"| TI-92P/V200\n"\
"     pea      0x5A2E.w\n"\
"____drawline:\n"\
"    movea.l  (0x9F0,%a4),%a0\n"\
"    jsr      (%a0)                | call memset (draws bottom line)\n"\
"____other_model:\n"\
"    movea.l  (%a4),%a0            | FirstWindow\n"\
"    movea.l  (%a0),%a0            | dereference the pointer\n"\
"____dirtywindows:\n"\
"    ori.w    #0x2000,(%a0)        | set Dirty Flag\n"\
"    tst.l    (0x22,%a0)           | is there another window?\n"\
"    movea.l  (0x22,%a0),%a0       | movea does not affect ccr\n"\
"    bne.s    ____dirtywindows\n"\
"    lea      (0xC,%a7),%a7\n"\
"    movem.l  (%a7)+,%d0-%d7/%a0-%a6\n"\
"    rts");


/* ------------------------------- myint5 ---------------------------------- *\
\* ========================================================================= */
// interrupt 5 is executed 19 times per secound
DEFINE_INT_HANDLER (myint5)
{
	if (resetint)
    resetint = seconds = counter = 0;
  
  if (startint)
    counter++;
    
  if (counter == 19)
  {
  	seconds += 1;
  	counter  = 0;
  }
  
  ExecuteHandler(oldint5);
}


/* ------------------------------ centerText ------------------------------- *\
\* ========================================================================= */
// centers a text on the screen of a TI-89, TI-92p or V200
void centerText(const char *buffer, int y)
{
	MoveTo((LCD_WIDTH-strlen(buffer)*6)/2,y);
	printf(buffer);
}


/* -------------------------------- getPwd --------------------------------- *\
\* ========================================================================= */
// this procedure is used to ask for passwords
// the characters are printed as * and are centered
int getPwd(char *buffer, int y)
{
	volatile short key;  // pressed keys are saved here temporarily
	unsigned short i;    // the number of pressed keys
	unsigned short a;    // necessary for clearing the line

	buffer[0] = 0;
	i         = 0;

	if(kbhit())
	  ngetchx();

	startint = 1;        // my interrupt must start now

	do
	{
		if (kbhit())
		{
		  startint = 0;

		  key = ngetchx();

  		MoveTo(0, y);                  // move cursor to the beginning of the line
	  	for(a = 0; a <= LCD_WIDTH; a+= 6)
		  	printf(" ");                 // and clear the line with spaces

  		if(key == KEY_APPS)
	  		return 0;

  		if(key == KEY_BACKSPACE && i)  // if [BACKSPACE] was pressed an i isn't zero (no key was pressed yet)
	  	{
		  	i--;
			  buffer[i] = 0;
  		}
	  	else if(key >= ' ' && key <= '~') // if it is a "valid" key (only characters, numbers and spaces)
  		{
	  		buffer[i++]=key;  // increase i by 1 and save key to buffer on position i
		  	buffer[i+1]=0;    // strings always have to end with a zero!
  		}

	  	MoveTo((LCD_WIDTH-i*6)/2, y);

		  if(key != KEY_ENTER)        // if key wasn't [ENTER]
			  for(a = 1; a <= i; a++)   // print * for each character
	    	  printf("*");
	    	  
	    resetint = 1;
	    startint = 1;
	  }
	  
	  if (seconds >= 5)
		  return 2;

	} while(key != KEY_ENTER); // do this until [ENTER] is pressed

	return 1;
}


/* ------------------------------- getNewPwd ------------------------------- *\
\* ========================================================================= */
// changes the password
int getNewPwd(void)
{
	char	buffer[16];
	char	buffer2[16];

	ClrScr();
	
	resetint = 1;
	startint = 0;

	centerText("Old password:", (LCD_HEIGHT-20)/2);
	if ((getPwd(buffer, (LCD_HEIGHT-20)/2+10)) == 2)
		return 2;

	if (strcmp(buffer,pwd))  // if the password was wrong
		return 0;              // return zero

	ClrScr();

	centerText("New password:", (LCD_HEIGHT-20)/2);
	if ((getPwd(buffer, (LCD_HEIGHT-20)/2+10) == 2))
	  return 2;

	ClrScr();

	centerText("Confirm password:", (LCD_HEIGHT-20)/2);
	if ((getPwd(buffer2, (LCD_HEIGHT-20)/2+10) == 2))
    return 2;

	if (strcmp(buffer,buffer2))  // if the first and the secound password are not the same
		return 0;                  // return zero

	sprintf(pwd, buffer);
	
	// save password
	savedPwd0 = pwd[0];
	savedPwd1 = pwd[1];
	savedPwd2 = pwd[2];
	savedPwd3 = pwd[3];
	savedPwd4 = pwd[4];
	savedPwd5 = pwd[5];
	savedPwd6 = pwd[6];
	savedPwd7 = pwd[7];
	savedPwd8 = pwd[8];
	savedPwd9 = pwd[9];
	savedPwd10 = pwd[10];
	savedPwd11 = pwd[11];
	savedPwd12 = pwd[12];
	savedPwd13 = pwd[13];
	savedPwd14 = pwd[14];
	savedPwd15 = pwd[15];

	return 1;
}


/* ------------------------------- wrongPwd -------------------------------- *\
\* ========================================================================= */
// this procedure is executed if the password was wrong
void wrongPwd(void)
{	
	ClrScr();

	centerText("Wrong password", (LCD_HEIGHT-20)/2);
	centerText("--------------", (LCD_HEIGHT-20)/2+10);

  resetint = 1;
  startint = 1;

  while (TRUE)
  {
   	if (seconds >= 2)
     	break;
  }
}


/* --------------------------------- main ---------------------------------- *\
\* ========================================================================= */
void _main(void)
{
	char buffer[16];
	int  i, j;               // temporarily used to check if no key was pressed for more than 2 seconds
	
	// load password
	pwd[0] = savedPwd0;
	pwd[1] = savedPwd1;
	pwd[2] = savedPwd2;
	pwd[3] = savedPwd3;
	pwd[4] = savedPwd4;
	pwd[5] = savedPwd5;
	pwd[6] = savedPwd6;
	pwd[7] = savedPwd7;
	pwd[8] = savedPwd8;
	pwd[9] = savedPwd9;
	pwd[10] = savedPwd10;
	pwd[11] = savedPwd11;
	pwd[12] = savedPwd12;
	pwd[13] = savedPwd13;
	pwd[14] = savedPwd14;
	pwd[15] = savedPwd15;

	FontSetSys(F_6x8);

	oldint5  = GetIntVec(AUTO_INT_5);    // get adress of original interrupt
	SetIntVec(AUTO_INT_5, myint5);       // replace interrupt 5 with my interrupt

	Start:
	ClrScr();
	startint = 0;                        // my interrupt mustn't start now
	resetint = 1;                        // reset my interrupt
	off();

	centerText("Enter password:", (LCD_HEIGHT-20)/2);

	if(!(j = getPwd(buffer,(LCD_HEIGHT-20)/2+10)))  // if [APPS] was pressed
	{
		if (!(i = getNewPwd()))              // if changing password failed
		{
			wrongPwd();
			goto Start;
		}
		else
		{
		  if (i == 2)                        // if no key was pressed for more than 2 seconds
			  goto Start;
		  else                               // if password was changed successfully
		  	goto End;                        // quit program
		}
	}
	else
	{
		if (j == 2)                        // if no key was pressed for more than 2 seconds
    {
			goto Start;
		}
	}

	if(strcmp(buffer,pwd))           // if password was wrong
	{
		wrongPwd();
		goto Start;
	}
  
  End:
	SetIntVec(AUTO_INT_5, oldint5);                    // restore original interrupt 5
	HomeScreenRestore();                               // restore Home Screen
	ST_showHelp("PWD 1.3 - http://www.fasmat.at.tc");	 // show info
}